<?php
// if this var is not set, we have no config, so get out
if ($webdom=='') {
    header("Location: /");
    die();
}

$msdbconn=msdbconnect();

// move Stock from one Warehouse to another using defined Inventory Document and Transaction
if ($operation=='STOCKMOVE' && $wpisopen) {
    include($incdir.'mssql/istocks_mov.php');
}
// update Stock in a Warehouse via [PeriodicConsumptionItems].[PhysicalInventory]
if ($operation=='STOCKUPDATE') {
    include($incdir.'mssql/istocks_upd.php');
}

// [PeriodicConsumptionItems] for Warehouse 1 [SHOP]
$arrayname='iconsumptionwh1';
$SQLWHERE ="wp.[Id] = (SELECT max([Id]) FROM [WorkPeriods] WHERE [StartDate]!=[EndDate])"."\r\n";
$SQLWHERE.=" AND  pci.[WarehouseConsumptionId]=wc.[Id]"."\r\n";
$SQLWHERE.=" AND wh.[Name]='".$wh[1]['Name']."'"."\r\n";
include($incdir.'mssql/ipcis_sel.php');

// [PeriodicConsumptionItems] for Warehouse 2 [BODEGA]
$arrayname='iconsumptionwh2';
$SQLWHERE ="wp.[Id] = (SELECT max([Id]) FROM [WorkPeriods] WHERE [StartDate]!=[EndDate])"."\r\n";
$SQLWHERE.=" AND  pci.[WarehouseConsumptionId]=wc.[Id]"."\r\n";
$SQLWHERE.=" AND wh.[Name]='".$wh[2]['Name']."'"."\r\n";
include($incdir.'mssql/ipcis_sel.php');

// Warehouse 1 [Local Warehouses] [SHOP]
$arrayname='wh1';
$SQLWHERE="wt.[Name]='".$wht[1]['Name']."' AND wh.[Name]='".$wh[1]['Name']."'";
include($incdir.'mssql/warehouses_sel.php');

// Warehouse 2 [Local Warehouses] [BODEGA]
$arrayname='wh2';
$SQLWHERE="wt.[Name]='".$wht[1]['Name']."' AND wh.[Name]='".$wh[2]['Name']."'";
include($incdir.'mssql/warehouses_sel.php');

// Inventory Document Type which transfers stock from Warehouse 1 [SHOP] to Warehouse 2 [BODEGA]
$arrayname='idoctypewh1';
$SQLWHERE ="itdt.[Name] like '%Txfr%' AND whs.[Name]='".$wh[1]['Name']."' AND wht.[Name]='".$wh[2]['Name']."'"."\r\n";
include($incdir.'mssql/itxdoctypes_sel.php');

// Inventory Document Type which transfers stock from Warehouse 2 [BODEGA] to Warehouse 1 [SHOP]
$arrayname='idoctypewh2';
$SQLWHERE ="itdt.[Name] like '%Txfr%' AND whs.[Name]='".$wh[2]['Name']."' AND wht.[Name]='".$wh[1]['Name']."'"."\r\n";
include($incdir.'mssql/itxdoctypes_sel.php');

// Inventory Transactions for Warehouse 1 [SHOP] where it is the Source or Target
$arrayname='itransactionswh1';
$SQLWHERE ="([SourceWarehouseId]=(SELECT [Id] FROM [Warehouses] WHERE [Name]='".$wh[1]['Name']."')"."\r\n";
$SQLWHERE.="OR [TargetWarehouseId]=(SELECT [Id] FROM [Warehouses] WHERE [Name]='".$wh[1]['Name']."')"."\r\n";
$SQLWHERE.=") AND [Date]>='".$wpdate."'"."\r\n";
include($incdir.'mssql/itransactions_sel.php');

// Inventory Transactions for Warehouse 2 [BODEGA] where it is the Source or Target
$arrayname='itransactionswh2';
$SQLWHERE ="([SourceWarehouseId]=(SELECT [Id] FROM [Warehouses] WHERE [Name]='".$wh[2]['Name']."')"."\r\n";
$SQLWHERE.="OR [TargetWarehouseId]=(SELECT [Id] FROM [Warehouses] WHERE [Name]='".$wh[2]['Name']."')"."\r\n";
$SQLWHERE.=") AND [Date]>='".$wpdate."'"."\r\n";
include($incdir.'mssql/itransactions_sel.php');




/*************************/
// Inventory Items
/*************************/

switch ($screen) {
    CASE 'ORDER':
        // SQL WHERE statement to filter the rest of the Inventory Item list
        $SQLWHERE ='ii.[Id] NOT IN ('."\r\n";
        $SQLWHERE.="SELECT [InventoryId] FROM [InvRequests] where [Active]=1 AND [Status]='".$statusfilter."'"."\r\n";
        $SQLWHERE.=')'."\r\n";
        break;
    CASE 'REQUEST':
        // SQL WHERE statement to filter the rest of the Inventory Item list
        $SQLWHERE ='ii.[Id] NOT IN('."\r\n";
        $SQLWHERE.="SELECT [InventoryId] FROM [InvRequests] where [Active]=1 AND [Status]='".$statusfilter."'"."\r\n";
        $SQLWHERE.=')'."\r\n";
        $SQLWHERE.=' AND ii.[Id] NOT IN ('."\r\n";
        $SQLWHERE.='SELECT [Id] FROM [InventoryItems] where [Warehouse] IN('."\r\n";
        $SQLWHERE.="SELECT [Name] FROM [Warehouses] WHERE [Name] IN("."\r\n";
        $SQLWHERE.="'Cerveceria','Sula'"."\r\n";
        $SQLWHERE.=')'."\r\n";
        $SQLWHERE.=')'."\r\n";
        $SQLWHERE.=')'."\r\n";
        break;
    DEFAULT:
        $SQLWHERE='';
        break;
}

// Item Type Filter [GroupCode]
if ($igroupcodefilter!='ALL' && $igroupcodefilter!='') {
    $SQLWHERE.=($SQLWHERE!='' ? ' AND ' : '').'[GroupCode]='."'".$igroupcodefilter."'";
}
// Warehouse Filter (Supplier Entity Warehouse)
if ($warehousefilter!='ALL' && $warehousefilter!='') {
    $SQLWHERE.=($SQLWHERE!='' ? ' AND ' : '').'[Warehouse]='."'".$warehousefilter."'";
}
// get Inventory Items, filtered by preceding SQLWHERE conditions
include($incdir.'mssql/iitems_sel.php');


if($msdbconn) {sqlsrv_close($msdbconn);}


// SECTION: Inventory Container

echo '<!-- container-group INVENTORYITEMS beg -->'."\r\n";
echo '<DIV class="container-group" style="background-color:'.$wrappercolor.';color:#FFFFFF;padding:2px;margin-bottom:10px;font-size:14px;text-shadow:1px 1px 1px #202020;">'."\r\n\r\n";

echo '<SECTION id="content-top" style="background-color:'.$wrappercolor.';font-size:14px;padding:4px;white-space:nowrap;">'."\r\n";
echo '<span class="collapsable" title="Click here to collapse/expand this section" onclick="expandcollapse('."'inventoryitemsection')".'">';

if($screen=='STOCK') {
    echo '&nbsp;';
    echo ($wpisopen ? '<b>*** WorkPeriod is Open. Stock Counts are approximate, and Physical updates are disabled. ***</b>' : '');
    echo (!$wpisopen ? '<b>*** WorkPeriod is Closed. Stock Movements are disabled. ***</b>' : '');
}
echo '</span>'."\r\n";

echo '</SECTION>'."\r\n\r\n";

echo '<!-- container-group INVENTORYITEMS container beg -->'."\r\n";
echo '<DIV ID="inventoryitemsection" class="container-group" style="background-color:#331133;margin:0px;padding:2px;">'."\r\n\r\n";

// SECTION: Title

if($screen=='ORDER' || $screen=='REQUEST') {
    $sectiontitle=($screen!='' ? ($invreqscount>0 ? 'Other ' : '').'Items you can '.$screen.' :: ' : '');
} else {
    $sectiontitle='&nbsp;Stock at '.$wh[1]['Name'].' (left) &amp; '.$wh[2]['Name'].' (right) :: ';
}
$sectiontitle.=$inventoryitemscount;
if($screen=='ORDER' || $screen=='REQUEST') {
    $sectiontitle.='&nbsp;(Stock at '.$wh[2]['Name'].' is shown)';
}
echo '<SECTION id="content-top" style="padding:3px;white-space:nowrap;">'."\r\n";
echo $sectiontitle;
echo '&nbsp;&nbsp; '."\r\n";
echo '</SECTION>'."\r\n\r\n";


/*************************/
// SECTION: Inventory Items

echo '<!-- content-page beg -->'."\r\n";
echo '<SECTION id="content-page">'."\r\n\r\n";

for ($i=1; $i<=$inventoryitemscount; $i++) {

$iid=$inventoryitems[$i]['Id'];
$additionalunits=${'iiunits'.$inventoryitems[$i]['Id']};
$additionalunitscount=count($additionalunits);
$defaulttxunit='';

echo comment(' ................. r:'.$i.' sid:'.$sid.' pid:'.$pid.' iid:'.$iid.' screen:'.$screen.' operation:'.$operation.' ................. ')."\r\n\r\n";

echo '<DIV CLASS="action-container">'."\r\n\r\n";

/********** COMMON **********/
    echo '<!-- stock-item common BEG -->'."\r\n";

    echo '<DIV CLASS="stock-item" style="width:360px;" title="'.$inventoryitems[$i]['Name'].' ('.$inventoryitems[$i]['Warehouse'].')'.'" ID="'.$inventoryitems[$i]['Id'].'">'."\r\n";

        echo '<INPUT TYPE="text" class="producttype" NAME="Product_Type" size="12" VALUE="'.$inventoryitems[$i]['GroupCode'].'" disabled>'."\r\n";
        echo '<span class="boldyellow">'.$inventoryitems[$i]['Name'].'</span>'."\r\n";

        echo '<INPUT TYPE="hidden" id="inventoryid_'.$inventoryitems[$i]['Id'].'" VALUE="'.$inventoryitems[$i]['Id'].'" title="InventoryId">'."\r\n";

        echo '<INPUT TYPE="hidden" id="dtrequest_'.$inventoryitems[$i]['Id'].'" VALUE="'.date("Y-m-d H:i:s").'.000" title="Request Date/Time">'."\r\n";

        echo '<INPUT TYPE="hidden" id="tumultiplier_'.$inventoryitems[$i]['Id'].'" VALUE="'.$inventoryitems[$i]['TransactionUnitMultiplier'].'" title="TU Multiplier">'."\r\n";

    echo '</DIV>'."\r\n";

    echo '<!-- stock-item common END -->'."\r\n\r\n";



    /********** Stock Count Compute: BEG **********/
    // this will fill the following variables
        // SHOP
        $wh1itemcountlarge=0;
        $wh1itemcountsmall=0;
        $wh1itempcid=0;
        // BODEGA
        $wh2itemcountlarge=0;
        $wh2itemcountsmall=0;
        $wh2itempcid=0;

        include($incdir.'mssql/istocks_compute.php');
    /********** Stock Count Compute: END **********/



/********** Stock Count Display: SHOP **********/

if ($screen=='STOCK') {
    $itemcountadditional=$wh1itemcountadditional;
    $additionalunits=$wh1additionalunits;
    $itemcountlarge=number_format((float)$wh1itemcountlarge, 2, '.', '');
    $itemcountsmall=number_format((float)$wh1itemcountsmall, 0, '.', '');
    $itempcid=$wh1itempcid;

    echo comment(' ***** SHOP ***** ')."\r\n\r\n";

echo '<DIV CLASS="stock-count-area" style="width:auto;background:#444444;padding:0px;margin:0px;" title="Stock at '.$wh[1]['Name'].'">';

    echo '<DIV CLASS="stock-count-area" title="Stock at '.$wh[1]['Name'].'">'."\r\n";
    echo '<span class="stock-unit">'.$inventoryitems[$i]['BaseUnit'].'<br />'.'</span>'."\r\n";
    echo '<span class="stock-count">'.$itemcountsmall.'</span>'."\r\n";
    echo '</DIV>'."\r\n";

    echo '<DIV CLASS="stock-count-area"'.($inventoryitems[$i]['TransactionUnit'] ? '' : ' style="background:#444444"').' title="Stock at '.$wh[1]['Name'].'">'."\r\n";
    echo '<span class="stock-unit">'.($inventoryitems[$i]['TransactionUnit'] ? $inventoryitems[$i]['TransactionUnit'] : '&nbsp;').'<br />'.'</span>'."\r\n";
    echo '<span class="stock-count">'.($inventoryitems[$i]['TransactionUnit'] ? $itemcountlarge : '&nbsp;').'</span>'."\r\n";
    echo '</DIV>'."\r\n";

    echo '<br />';
    //for ($a=1; $a<=$additionalunitscount; $a++) {
    for ($a=$additionalunitscount; $a>0; $a--) {
        if ($additionalunits[$a]['Name']!='') {
            echo '<DIV CLASS="stock-count-area" title="Stock at '.$wh[1]['Name'].'">'."\r\n";
            echo '<span class="stock-unit">'.$additionalunits[$a]['Name'].'<br />'.'</span>'."\r\n";
            echo '<span class="stock-count">'.number_format((float)$additionalunits[$a]['Count'], 2, '.', '').'</span>'."\r\n";
            echo '</DIV>'."\r\n";
        }
    }
    echo $additionalunitscount ? '' : '<br />&nbsp;'."\r\n";

echo '</DIV>'."\r\n";

    echo '<!-- stock-item SHOP -->'."\r\n\r\n";


/********** ACTIONS: SHOP **********/
    echo comment(' ***** ACTIONS ***** ')."\r\n\r\n";

    if (!$wpisopen) {
        $butbgcolor=($itempcid>0 ? '333399' : '555555');
        echo '<DIV CLASS="action-button" style="background-color:#'.$butbgcolor.';font-size:8px" title="UPDATE '.$screen.' at '.$wh[1]['Name'].'"';
        echo ' id="stockupdate_'.$inventoryitems[$i]['Id'].'"';
        if ($itempcid>0) {
        echo ' onclick="stockupdate(';
        echo "'".$inventoryitems[$i]['Id']."'";
        echo ",'".$itempcid."'";
        echo ')"';
        }
        echo '>'.($itempcid>0 ? 'UPD' : '&nbsp;&nbsp;--&nbsp;&nbsp;').'</DIV>'."\r\n\r\n";
    }

    if ($wpisopen) {
        echo '<DIV CLASS="action-button" style="background-color:#550099;font-size:8px" title="Move from '.$wh[1]['Name'].' to '.$wh[2]['Name'].'"';
        echo ' id="stockmove_'.$inventoryitems[$i]['Id'].'"';
        echo ' onclick="stockmove(';
        echo "'L2R'";
        echo ",'".$inventoryitems[$i]['Id']."'";
        echo ",'".$idoctypewh1[1]['iDocTypeId']."'";
        echo ')"';
        echo '>MOVE &gt;</DIV>'."\r\n\r\n";
    }

} // if ($screen=='STOCK')


/********** SELECTORS: COMMON **********/
    if($screen=='ORDER') {
    echo '<DIV CLASS="stock-item" style="width:190px;">'."\r\n";
        echo '<SELECT size="1" id="selectedwarehouse_'.$inventoryitems[$i]['Id'].'" title="Warehouse">'."\r\n";
        for ($s=1; $s<=$warehousescount; $s++) {
            echo '<OPTION VALUE="'.$warehouses[$s]['Id'].'"';
            echo ($inventoryitems[$i]['Warehouse']==$warehouses[$s]['Name'] ? ' selected' : '');
            echo '>';
            echo $warehouses[$s]['Name'].'</OPTION>'."\r\n";
        }
        echo '</SELECT>'."\r\n\r\n";
    echo '</DIV>'."\r\n\r\n";
    }

    echo '<DIV CLASS="stock-item" style="width:200px;">'."\r\n";

    $plusminus='MINUSSTOCK';
    echo '<DIV CLASS="plusminus-button"';
    echo ' onclick="plusminus(';
    echo     "'".$plusminus."'";
    echo ','."'".$inventoryitems[$i]['Id']."'";
    echo ')"';
    echo '> - </DIV>'."\r\n";

    $plusminus='PLUSSTOCK';
    echo '<DIV CLASS="plusminus-button"';
    echo ' onclick="plusminus(';
    echo     "'".$plusminus."'";
    echo ','."'".$inventoryitems[$i]['Id']."'";
    echo ')"';
    echo '> + </DIV>'."\r\n\r\n";

    echo '<INPUT TYPE="text" id="q_'.$inventoryitems[$i]['Id'].'" size="2" VALUE="1" title="Quantity">'."\r\n\r\n";

    echo '<SELECT size="1" id="unit_'.$inventoryitems[$i]['Id'].'" name="unit_'.$inventoryitems[$i]['Id'].'" title="Unit">'."\r\n";
        $defaulttxunit='';
        for ($a=1;$a<=$additionalunitscount; $a++) {
            $defaulttxunit=($defaulttxunit!='' ? $defaulttxunit : ($additionalunits[$a]['IsDefaultTransactionUnit']==1 ? $additionalunits[$a]['Name'] : ''));
            echo '<OPTION VALUE="'.$additionalunits[$a]['Name'].'"';
            echo ($defaulttxunit==$additionalunits[$a]['Name'] ? ' selected' : '');
            echo '>';
            echo $additionalunits[$a]['Name'].'</OPTION>'."\r\n";
        }
        if ($inventoryitems[$i]['TransactionUnit']!='' && $inventoryitems[$i]['TransactionUnitMultiplier']!=0) {
            $defaulttxunit=($defaulttxunit!='' ? $defaulttxunit : $inventoryitems[$i]['TransactionUnit']);
            echo '<OPTION VALUE="'.$inventoryitems[$i]['TransactionUnit'].'"';
            echo ($defaulttxunit==$inventoryitems[$i]['TransactionUnit'] ? ' selected' : '');
            echo '>';
            echo $inventoryitems[$i]['TransactionUnit'].'</OPTION>'."\r\n";
        }
        $defaulttxunit=($defaulttxunit!='' ? $defaulttxunit : $inventoryitems[$i]['BaseUnit']);
        echo '<OPTION VALUE="'.$inventoryitems[$i]['BaseUnit'].'"';
        echo ($defaulttxunit==$inventoryitems[$i]['BaseUnit'] ? ' selected' : '');
        echo '>';
        echo $inventoryitems[$i]['BaseUnit'].'</OPTION>'."\r\n";
    echo '</SELECT>'."\r\n\r\n";

    if($screen=='REQUEST') {
        $warehouseid=0;
        for ($s=1; $s<=$warehousescount; $s++) {
            if ($warehouses[$s]['Name']==$wh[2]['Name']) {
                $warehouseid=$warehouses[$s]['Id'];
                break;
            }
        }
        echo '<INPUT type="hidden" id="selectedwarehouse_'.$inventoryitems[$i]['Id'].'" VALUE="'.$warehouseid.'">'."\r\n";
    }

    echo '</DIV>'."\r\n\r\n";


/********** ACTIONS: BODEGA **********/
    $additionalunits=$wh2additionalunits;
    $itemcountlarge=number_format((float)$wh2itemcountlarge, 2, '.', '');
    $itemcountsmall=number_format((float)$wh2itemcountsmall, 0, '.', '');
    $itempcid=$wh2itempcid;

if ($screen=='STOCK') {
    if ($wpisopen) {
        echo '<DIV CLASS="action-button" style="background-color:#550000;font-size:8px" title="Move from '.$wh[2]['Name'].' to '.$wh[1]['Name'].'"';
        echo ' id="stockmove_'.$inventoryitems[$i]['Id'].'"';
        echo ' onclick="stockmove(';
        echo "'R2L'";
        echo ",'".$inventoryitems[$i]['Id']."'";
        echo ",'".$idoctypewh2[1]['iDocTypeId']."'";
        echo ')"';
        echo '>&lt; MOVE</DIV>'."\r\n\r\n";
    }

    if (!$wpisopen) {
        $butbgcolor=($itempcid>0 ? '333399' : '555555');
        echo '<DIV CLASS="action-button" style="background-color:#'.$butbgcolor.';font-size:8px" title="UPDATE '.$screen.' at '.$wh[2]['Name'].'"';
        echo ' id="stockupdate_'.$inventoryitems[$i]['Id'].'"';
        if ($itempcid>0) {
        echo ' onclick="stockupdate(';
        echo "'".$inventoryitems[$i]['Id']."'";
        echo ",'".$itempcid."'";
        echo ')"';
        }
        echo '>'.($itempcid>0 ? 'UPD' : '&nbsp;&nbsp;--&nbsp;&nbsp;').'</DIV>'."\r\n\r\n";
    }

} // if ($screen='STOCK')


/********** Stock Count Display: BODEGA **********/

    echo comment(' ***** BODEGA ***** ')."\r\n\r\n";

echo '<DIV CLASS="stock-count-area" style="width:auto;background:#444444;padding:0px;margin:0px;" title="Stock at '.$wh[2]['Name'].'">';

    echo '<DIV CLASS="stock-count-area" title="Stock at '.$wh[2]['Name'].'">'."\r\n";
    echo '<span class="stock-unit">'.$inventoryitems[$i]['BaseUnit'].'<br />'.'</span>'."\r\n";
    echo '<span class="stock-count">'.$itemcountsmall.'</span>'."\r\n";
    echo '</DIV>'."\r\n";

    //if ($inventoryitems[$i]['TransactionUnit']!='') {
        echo '<DIV CLASS="stock-count-area"'.($inventoryitems[$i]['TransactionUnit'] ? '' : ' style="background:#444444"').' title="Stock at '.$wh[2]['Name'].'">'."\r\n";
        echo '<span class="stock-unit">'.($inventoryitems[$i]['TransactionUnit'] ? $inventoryitems[$i]['TransactionUnit'] : '&nbsp;').'<br />'.'</span>'."\r\n";
        echo '<span class="stock-count">'.($inventoryitems[$i]['TransactionUnit'] ? $itemcountlarge : '&nbsp;').'</span>'."\r\n";
        echo '</DIV>'."\r\n";
    //}

    echo '<br />';
    //for ($a=1; $a<=$additionalunitscount; $a++) {
    for ($a=$additionalunitscount; $a>0; $a--) {
    if ($additionalunits[$a]['Name']!='') {
        echo '<DIV CLASS="stock-count-area" title="Stock at '.$wh[2]['Name'].'">'."\r\n";
        echo '<span class="stock-unit">'.$additionalunits[$a]['Name'].'<br />'.'</span>'."\r\n";
        echo '<span class="stock-count">'.number_format((float)$additionalunits[$a]['Count'], 2, '.', '').'</span>'."\r\n";
        echo '</DIV>'."\r\n";
    }
    }
    echo $additionalunitscount ? '' : '<br />&nbsp;';

echo '</DIV>';

    echo '<!-- stock-item BODEGA -->'."\r\n\r\n";


/********** ACTIONS: ORDER, REQUEST **********/
if ($screen=='ORDER' || $screen=='REQUEST') {
    echo '<DIV CLASS="action-button" style="background-color:#339933" title="'.$screen.': '.$inventoryitems[$i]['Name'].'"';
    echo ' value="'.$inventoryitems[$i]['Id'].'"';
    echo ' onclick="pf(';
    echo     "'".$screen."'";
    echo ','."'".$inventoryitems[$i]['Id']."'";
    echo ')"';
    echo '>'.$screen.'</DIV>'."\r\n";
}

echo "\r\n".'</DIV>'."\r\n";
echo '<!-- action-container end -->'."\r\n";
} // for ($i=1; $i<=$inventoryitemscount; $i++)



/********** END **********/

echo "\r\n".'</SECTION>'."\r\n";
echo '<!-- #content-page end  -->'."\r\n\r\n";

echo '</DIV><!-- container-group INVENTORYITEMS container end -->'."\r\n\r\n";
echo '</DIV><!-- container-group INVENTORYITEMS end -->'."\r\n\r\n";

?>
