<?php
$dttx=date("Y-m-d H:i:s.000");

// select Periodic Consumption Item
$cqry = "SELECT [InventoryItemId], [InventoryItemName], [UnitName], [UnitMultiplier], [PhysicalInventory]"."\r\n";
$cqry.= "FROM [PeriodicConsumptionItems]"."\r\n";
$cqry.= "WHERE [Id]=".$periodicconsumptionid."\r\n";
$records = msexecquery($msdbconn,$cqry);
$rc=count($records);
if ($rc==0) {
    die("Failed to get PeriodicConsumption Item ID=".$periodicconsumptionid);
}
$pciunit=$records[1]['UnitName'];
$pcimult=$records[1]['UnitMultiplier'];

// select Inventory Item and Units
$cqry = "SELECT [Name], [BaseUnit], [TransactionUnit], [TransactionUnitMultiplier] FROM [InventoryItems] WHERE [Id]=".$inventoryid;
$records = msexecquery($msdbconn,$cqry);
$rc=count($records);
if ($rc==0) {
    die("Failed to get Inventory Item ID=".$inventoryid);
}
$inventoryname=$records[1]['Name'];
$iBaseUnit=$records[1]['BaseUnit'];
$iTransactionUnit=$records[1]['TransactionUnit'];
$iTransactionUnitMultiplier=$records[1]['TransactionUnitMultiplier'];
$isTxUnitUsed=($iTransactionUnit!='' && $iTransactionUnitMultiplier>0 ? true : false);

// select Additional Units
$cqry = "SELECT [Name], [Multiplier], [ParentUnitName], [ParentUnitMultiplier], [IsDefaultTransactionUnit]"."\r\n";
$cqry.= "FROM [InventoryItemUnits]"."\r\n";
$cqry.= "WHERE [InventoryItemId]=".$inventoryid."\r\n";
$cqry.= "ORDER BY [Multiplier] DESC"."\r\n";
$records = msexecquery($msdbconn,$cqry);
$rc=count($records);
$aunits=$records;

// determine Quantity of PeriodicConsumption Unit

$basequantity=0;
$txunitmultiplier=1;
$defaulttxunit='';

if ($rc>0) {
    for ($r=1; $r<=$rc; $r++) {
        if ($aunits[$r]['IsDefaultTransactionUnit']==1) {
            $defaulttxunit=$aunits[$r]['Name'];
            $txunitmultiplier=$aunits[$r]['Multiplier'];
        }
        if ($unit==$aunits[$r]['Name']) {
            $basequantity=$quantity*$aunits[$r]['Multiplier'];
        }
    }
}

if ($isTxUnitUsed && $defaulttxunit=='') {
    $defaulttxunit=$iTransactionUnit;
    $txunitmultiplier=$iTransactionUnitMultiplier;
}
if ($unit==$iTransactionUnit) {
    $basequantity=$quantity*$iTransactionUnitMultiplier;
}

if ($defaulttxunit=='') {
    $defaulttxunit=$iBaseUnit;
    $txunitmultiplier=1;
}
if ($unit==$iBaseUnit) {
    $basequantity=$quantity;
}

$quantity=$basequantity/$pcimult;


if ($operation=='STOCKUPDATE') {
    $cqry = '';
    $cqry.='UPDATE [PeriodicConsumptionItems] SET'."\r\n";
    $cqry.=' [PhysicalInventory]='.$quantity."\r\n";
    $cqry.='WHERE [Id]='.$periodicconsumptionid."\r\n";

    $records = msexecquery($msdbconn,$cqry);
}


// clear vars
$cqry=null;
$records=null;
$rc=null;
?>