<?php
/////////////////////////////////////////////
// CONFIG VALUES THAT CAN BE CHANGED
//
// the order in which these variables
// appear and are defined can be important
// to proper site functionality, so it's
// best to not rearrange their order
/////////////////////////////////////////////

// the name of the website, and it's root URL
$webname = "Inventory";	//  MySiteName
$webdom = $_SERVER["HTTP_HOST"];	//  www.mydom.com
$weburl = 'http://'.$webdom;		//  http://www.mydom.com

// KEYWORDS to be used in META tags
$keywords = 'flarfernugen';

// DESCRIPTION to be used in META tags
$webdescription="Inventory Management System for SambaPOS";

// CSS file
$stylesheet = $updir.'zcss/inv.css';

// root path for images
$imgpath=$updir.'images/';
$photopath=$updir.'media/photos/';

// favicons
$favicons='';
//$favicons.='<link rel="shortcut icon" href="'.$imgpath.'icons/favico.ico" />'."\r\n";
//$favicons.='<link rel="icon" type="image/gif" href="'.$imgpath.'icons/favico.gif" />'."\r\n";
$favicons.='<link rel="shortcut icon" href="'.$imgpath.'apple-icon.png" />'."\r\n";


// E-mail server configuration parameters... used by the site outbound mailer
//include ($incdir.'mailer/configemailer.php');


/////////////////////////////////////////////
// REQUIRED FILES
//
// the following files are required for
// proper site functionality, and should
// not be moved from this area of this file
/////////////////////////////////////////////

// CONSTANT decalarations used throughout the site
include ($incdir.'constants.php');

// FUNCTION declarations used throughout the site
include ($incdir.'functions.php');

// DATABASE (DB) connectivity information
// alterations to this file may be required to coincide with the SQL configuration of the server
include ($incdir.'configdb.php');





/////////////////////////////////////////////
// CONFIGZ.PHP
//
// the following file is included to set
// up more variables that are required for
// proper site functionality and shouldn't
// be altered, unless you know what effect
// it can have
/////////////////////////////////////////////
include ($incdir.'configz.php');
?>
