<?php
$dttx=date("Y-m-d H:i:s.000");

// select Inventory Item and Units
$cqry = "SELECT [Name], [BaseUnit], [TransactionUnit], [TransactionUnitMultiplier] FROM [InventoryItems] WHERE [Id]=".$inventoryid;
$records = msexecquery($msdbconn,$cqry);
$rc=count($records);
if ($rc==0) {
    die("Failed to get Inventory Item ID=".$inventoryid);
} else {
    $inventoryname=$records[1]['Name'];
    $iBaseUnit=$records[1]['BaseUnit'];
    $iTransactionUnit=$records[1]['TransactionUnit'];
    $iTransactionUnitMultiplier=$records[1]['TransactionUnitMultiplier'];
    $isTxUnitUsed=($iTransactionUnit!='' && $iTransactionUnitMultiplier>0 ? true : false);
}

// select Additional Units
$cqry = "SELECT [Name], [Multiplier], [ParentUnitName], [ParentUnitMultiplier], [IsDefaultTransactionUnit]"."\r\n";
$cqry.= "FROM [InventoryItemUnits]"."\r\n";
$cqry.= "WHERE [InventoryItemId]=".$inventoryid."\r\n";
$cqry.= "ORDER BY [Multiplier] DESC"."\r\n";
$records = msexecquery($msdbconn,$cqry);
$rc=count($records);


// determine Multiplier of Transaction Unit

$basequantity=0;
$txunitmultiplier=1;
$defaulttxunit='';

if ($rc>0) {
    for ($r=1; $r<=$rc; $r++) {
        if ($records[$r]['IsDefaultTransactionUnit']==1) {
            $defaulttxunit=$records[$r]['Name'];
            $txunitmultiplier=$records[$r]['Multiplier'];
        }
        if ($unit==$records[$r]['Name']) {
            $basequantity=$quantity*$records[$r]['Multiplier'];
            $multiplier=$records[$r]['Multiplier'];
        }
    }
}

if ($isTxUnitUsed && $defaulttxunit=='') {
    $defaulttxunit=$iTransactionUnit;
    $txunitmultiplier=$iTransactionUnitMultiplier;
}
if ($unit==$iTransactionUnit) {
    $basequantity=$quantity*$iTransactionUnitMultiplier;
    $multiplier=$iTransactionUnitMultiplier;
}

if ($defaulttxunit=='') {
    $defaulttxunit=$iBaseUnit;
    $txunitmultiplier=1;
}
if ($unit==$iBaseUnit) {
    $basequantity=$quantity;
    $multiplier=1;
}

//$quantity=$basequantity/$txunitmultiplier;

//echo $quantity.'-';
//echo $defaulttxunit.'-';
//echo $txunitmultiplier.'-';
//echo $basequantity.'-';
//echo $multiplier.'-';
//echo $quantity.'-';



// get DocType
$SQLWHERE ="itdt.[Id]=".$idoctypeid."\r\n";
include($incdir.'mssql/itxdoctypes_sel.php');
if ($inventorytxdoctypescount==0) {
    $errmsg="Failed to get iDocType.";
    die($errmsg);
}
$iDocTypeId=$inventorytxdoctypes[1]['iDocTypeId'];
$iDocTypeName=$inventorytxdoctypes[1]['iDocTypeName'].' ['.$inventoryname.']';
$iTxTypeId=$inventorytxdoctypes[1]['iTxTypeId'];
$iWarehouseSourceId=$inventorytxdoctypes[1]['WarehouseDefaultSourceId'];
$iWarehouseTargetId=$inventorytxdoctypes[1]['WarehouseDefaultTargetId'];

// create Doc
$cqry = '';
$cqry.='INSERT INTO [InventoryTransactionDocuments] ('."\r\n";
$cqry.=' [Date]'."\r\n";
$cqry.=',[Name]'."\r\n";
$cqry.=') VALUES ('."\r\n";
$cqry.=' '."'".$dttx."'"."\r\n";
$cqry.=','."'".$iDocTypeName."'"."\r\n";
$cqry.=')'."\r\n";

$records = msexecquery($msdbconn,$cqry);
$rc=count($records);

// select Doc
$cqry = "SELECT [Id] FROM [InventoryTransactionDocuments] WHERE [Name]='".$iDocTypeName."'";
$cqry.= " AND [Date]='".$dttx."'";
$records = msexecquery($msdbconn,$cqry);
$rc=count($records);
$iDocId=$records[1]['Id'];

if ($iDocId==0) {
    $errmsg="Failed to create iDoc.";
    die($errmsg);
}


if ($operation=='STOCKMOVE' || ($operation=='FULFILL' && $screen=='REQUEST')) {
    $cqry = '';
    $cqry.='INSERT INTO [InventoryTransactions] ('."\r\n";
    $cqry.=' [InventoryTransactionDocumentId]'."\r\n";
    $cqry.=',[InventoryTransactionTypeId]'."\r\n";
    $cqry.=',[SourceWarehouseId]'."\r\n";
    $cqry.=',[TargetWarehouseId]'."\r\n";
    $cqry.=',[Date]'."\r\n";
    $cqry.=',[Unit]'."\r\n";
    $cqry.=',[Multiplier]'."\r\n";
    $cqry.=',[Quantity]'."\r\n";
    $cqry.=',[TotalPrice]'."\r\n";
    $cqry.=',[InventoryItem_Id]'."\r\n";

    $cqry.=') VALUES ('."\r\n";

    $cqry.=' '.$iDocId."\r\n";
    $cqry.=','.$iTxTypeId."\r\n";
    $cqry.=','.$iWarehouseSourceId."\r\n";
    $cqry.=','.$iWarehouseTargetId."\r\n";
    $cqry.=','."'".$dttx."'"."\r\n";
    $cqry.=','."'".$unit."'"."\r\n";
    $cqry.=','.($multiplier ? $multiplier : 1)."\r\n";
    $cqry.=','.$quantity."\r\n";
    //$cqry.=','.$unitcost."\r\n";
    $cqry.=',0'."\r\n";
    $cqry.=','.$inventoryid."\r\n";
    $cqry.=')'."\r\n";

    $records = msexecquery($msdbconn,$cqry);
    $rc=count($records);
}


// clear vars
$cqry=null;
$records=null;
$rc=null;
?>