<?php
# Wake on LAN - (c) HotKey@spr.at, upgraded by Murzik
# Modified by Allan Barizo http://www.hackernotcracker.com
flush();
function WakeOnLan($addr='', $mac='' ,$socket_number='9') {
    if ($addr==''  || $mac=='') {
        echo 'WakeOnLan: Supplied parameters not valid.';
        return FALSE;
    }
    echo 'Attempting to send packet to IP['.$addr.'], MAC['.$mac.'], port['.$socket_number.']...<br /><br />'."\r\n";
    // get Octets of MAC by exploding on colons (:)
    $addr_byte = explode(':', $mac);
    // re-assemble MAC without colons
    $hw_addr = '';
    for ($a=0; $a <6; $a++) {
        $hw_addr .= chr(hexdec($addr_byte[$a]));
    }
    
    // create magic packet
    // FFFFFFFFFFFF (FFx6) followed by 16 repetitions of the MAC
    $msg = chr(255).chr(255).chr(255).chr(255).chr(255).chr(255);
    for ($a = 1; $a <= 16; $a++) {
        $msg .= $hw_addr;    
    }
    
    // send it to the broadcast address using UDP
    // SQL_BROADCAST option isn't help!!
    $s = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
    if ($s == false) {
        echo "Error creating socket!\n";
        echo "Error code:'".socket_last_error($s)."' - " . socket_strerror(socket_last_error($s));
        return FALSE;
    } else {
        // sett broadcast option to socket
        $opt_ret = socket_set_option($s, 1, 6, TRUE);
        if($opt_ret <0) {
            echo "setsockopt() failed, error:" . strerror($opt_ret) . "\n";
            return FALSE;
        }
        // send Magic Packet
        if(socket_sendto($s, $msg, strlen($msg), 0, $addr, $socket_number)) {
            echo "Magic Packet sent successfully!";
            socket_close($s);
            return TRUE;
        } else {
            echo "Magic Packet FAILED!";
            return FALSE;
        }
    }
}

// Port number where computer is listening. Usually, any number between 1-50000 will do. Normally people choose 7 or 9.
$socket_number = "9";
// MAC Address of listening network device
$mac_addy = "E8:40:F2:0B:5F:3E";
// IP address of listening computer. Use the domain name if you prefer
$ip_addy = gethostbyname("myhomeserver.dynamicdns.org");
$ip_addy = '190.211.139.145';
WakeOnLan($ip_addy, $mac_addy,$socket_number)
?>

